/*
 * generated by Xtext 2.11.0
 */
package com.mncml.implementation.pogo.dsl.serializer;

import com.google.inject.Inject;
import com.mncml.implementation.pogo.dsl.services.PogoDslGrammarAccess;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public class PogoDslSyntacticSequencer extends AbstractSyntacticSequencer {

	protected PogoDslGrammarAccess grammarAccess;
	protected AbstractElementAlias match_ClassDescription_QualifiedNameParserRuleCall_10_1_q;
	protected AbstractElementAlias match_ClassDescription_QualifiedNameParserRuleCall_11_1_q;
	protected AbstractElementAlias match_ClassDescription_QualifiedNameParserRuleCall_12_1_q;
	protected AbstractElementAlias match_ClassDescription_QualifiedNameParserRuleCall_13_1_q;
	protected AbstractElementAlias match_ClassDescription_QualifiedNameParserRuleCall_9_1_q;
	protected AbstractElementAlias match_Command_QualifiedNameParserRuleCall_6_1_q;
	protected AbstractElementAlias match_Pipe_QualifiedNameParserRuleCall_7_1_q;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (PogoDslGrammarAccess) access;
		match_ClassDescription_QualifiedNameParserRuleCall_10_1_q = new TokenAlias(false, true, grammarAccess.getClassDescriptionAccess().getQualifiedNameParserRuleCall_10_1());
		match_ClassDescription_QualifiedNameParserRuleCall_11_1_q = new TokenAlias(false, true, grammarAccess.getClassDescriptionAccess().getQualifiedNameParserRuleCall_11_1());
		match_ClassDescription_QualifiedNameParserRuleCall_12_1_q = new TokenAlias(false, true, grammarAccess.getClassDescriptionAccess().getQualifiedNameParserRuleCall_12_1());
		match_ClassDescription_QualifiedNameParserRuleCall_13_1_q = new TokenAlias(false, true, grammarAccess.getClassDescriptionAccess().getQualifiedNameParserRuleCall_13_1());
		match_ClassDescription_QualifiedNameParserRuleCall_9_1_q = new TokenAlias(false, true, grammarAccess.getClassDescriptionAccess().getQualifiedNameParserRuleCall_9_1());
		match_Command_QualifiedNameParserRuleCall_6_1_q = new TokenAlias(false, true, grammarAccess.getCommandAccess().getQualifiedNameParserRuleCall_6_1());
		match_Pipe_QualifiedNameParserRuleCall_7_1_q = new TokenAlias(false, true, grammarAccess.getPipeAccess().getQualifiedNameParserRuleCall_7_1());
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (ruleCall.getRule() == grammarAccess.getQualifiedNameRule())
			return getQualifiedNameToken(semanticObject, ruleCall, node);
		return "";
	}
	
	/**
	 * QualifiedName:
	 *   ID ('.' ID)*;
	 */
	protected String getQualifiedNameToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "";
	}
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_ClassDescription_QualifiedNameParserRuleCall_10_1_q.equals(syntax))
				emit_ClassDescription_QualifiedNameParserRuleCall_10_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ClassDescription_QualifiedNameParserRuleCall_11_1_q.equals(syntax))
				emit_ClassDescription_QualifiedNameParserRuleCall_11_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ClassDescription_QualifiedNameParserRuleCall_12_1_q.equals(syntax))
				emit_ClassDescription_QualifiedNameParserRuleCall_12_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ClassDescription_QualifiedNameParserRuleCall_13_1_q.equals(syntax))
				emit_ClassDescription_QualifiedNameParserRuleCall_13_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_ClassDescription_QualifiedNameParserRuleCall_9_1_q.equals(syntax))
				emit_ClassDescription_QualifiedNameParserRuleCall_9_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Command_QualifiedNameParserRuleCall_6_1_q.equals(syntax))
				emit_Command_QualifiedNameParserRuleCall_6_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Pipe_QualifiedNameParserRuleCall_7_1_q.equals(syntax))
				emit_Pipe_QualifiedNameParserRuleCall_7_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Ambiguous syntax:
	 *     QualifiedName?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'ClassDescription' '{' QualifiedName? (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     (rule start) 'ClassDescription' '{' QualifiedName? (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     (rule start) 'ClassDescription' '{' QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     (rule start) 'ClassDescription' '{' QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     (rule start) 'ClassDescription' '{' QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     (rule start) 'ClassDescription' '{' QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     (rule start) 'ClassDescription' '{' QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule start)
	 *     description=EString QualifiedName? (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     description=EString QualifiedName? (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     description=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     description=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     description=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     description=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     description=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     filestogenerate=EString QualifiedName? (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     filestogenerate=EString QualifiedName? (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     filestogenerate=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     filestogenerate=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     filestogenerate=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     filestogenerate=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     filestogenerate=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     hasMandatoryProperty=Boolean (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     hasMandatoryProperty=Boolean (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     hasMandatoryProperty=Boolean (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     hasMandatoryProperty=Boolean (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     hasMandatoryProperty=Boolean (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     hasMandatoryProperty=Boolean (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     hasMandatoryProperty=Boolean (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     language=Language QualifiedName? (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     language=Language QualifiedName? (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     language=Language QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     language=Language QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     language=Language QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     language=Language QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     language=Language QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     license=EString QualifiedName? (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     license=EString QualifiedName? (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     license=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     license=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     license=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     license=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     license=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     sourcePath=EString QualifiedName? (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     sourcePath=EString QualifiedName? (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     sourcePath=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     sourcePath=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     sourcePath=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     sourcePath=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     sourcePath=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     title=EString QualifiedName? (ambiguity) 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     title=EString QualifiedName? (ambiguity) QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     title=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     title=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     title=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     title=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     title=EString QualifiedName? (ambiguity) QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 */
	protected void emit_ClassDescription_QualifiedNameParserRuleCall_10_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     QualifiedName?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule start)
	 *     description=EString QualifiedName? QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     description=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     description=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     description=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     description=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     description=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 *     filestogenerate=EString QualifiedName? QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     filestogenerate=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     filestogenerate=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     filestogenerate=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     filestogenerate=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     filestogenerate=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 *     hasConcreteProperty=Boolean (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     hasConcreteProperty=Boolean (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     hasConcreteProperty=Boolean (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     hasConcreteProperty=Boolean (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     hasConcreteProperty=Boolean (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     hasConcreteProperty=Boolean (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 *     hasMandatoryProperty=Boolean QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     hasMandatoryProperty=Boolean QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     hasMandatoryProperty=Boolean QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     hasMandatoryProperty=Boolean QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     hasMandatoryProperty=Boolean QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     hasMandatoryProperty=Boolean QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 *     language=Language QualifiedName? QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     language=Language QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     language=Language QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     language=Language QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     language=Language QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     language=Language QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 *     license=EString QualifiedName? QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     license=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     license=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     license=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     license=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     license=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 *     sourcePath=EString QualifiedName? QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     sourcePath=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     sourcePath=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     sourcePath=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     sourcePath=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     sourcePath=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 *     title=EString QualifiedName? QualifiedName? (ambiguity) 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     title=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     title=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     title=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     title=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     title=EString QualifiedName? QualifiedName? (ambiguity) QualifiedName? QualifiedName? '}' (rule end)
	 */
	protected void emit_ClassDescription_QualifiedNameParserRuleCall_11_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     QualifiedName?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule start)
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 *     hasAbstractCommand=Boolean (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     hasAbstractCommand=Boolean (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     hasAbstractCommand=Boolean (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     hasAbstractCommand=Boolean (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     hasAbstractCommand=Boolean (ambiguity) QualifiedName? '}' (rule end)
	 *     hasConcreteProperty=Boolean QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     hasConcreteProperty=Boolean QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     hasConcreteProperty=Boolean QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     hasConcreteProperty=Boolean QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     hasConcreteProperty=Boolean QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'comments' comments=Comments
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'identification' identification=ClassIdentification
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? (ambiguity) QualifiedName? '}' (rule end)
	 */
	protected void emit_ClassDescription_QualifiedNameParserRuleCall_12_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     QualifiedName?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     (rule start) 'ClassDescription' '{' QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule start)
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     description=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     filestogenerate=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 *     hasAbstractAttribute=Boolean (ambiguity) 'comments' comments=Comments
	 *     hasAbstractAttribute=Boolean (ambiguity) 'identification' identification=ClassIdentification
	 *     hasAbstractAttribute=Boolean (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     hasAbstractAttribute=Boolean (ambiguity) '}' (rule end)
	 *     hasAbstractCommand=Boolean QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     hasAbstractCommand=Boolean QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     hasAbstractCommand=Boolean QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     hasAbstractCommand=Boolean QualifiedName? (ambiguity) '}' (rule end)
	 *     hasConcreteProperty=Boolean QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     hasConcreteProperty=Boolean QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     hasConcreteProperty=Boolean QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     hasConcreteProperty=Boolean QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     hasMandatoryProperty=Boolean QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     language=Language QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     license=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     sourcePath=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'comments' comments=Comments
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'identification' identification=ClassIdentification
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) 'inheritances' '{' inheritances+=Inheritance
	 *     title=EString QualifiedName? QualifiedName? QualifiedName? QualifiedName? (ambiguity) '}' (rule end)
	 */
	protected void emit_ClassDescription_QualifiedNameParserRuleCall_13_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     QualifiedName?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'ClassDescription' '{' (ambiguity) 'hasConcreteProperty' hasConcreteProperty=Boolean
	 *     (rule start) 'ClassDescription' '{' (ambiguity) QualifiedName? 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     (rule start) 'ClassDescription' '{' (ambiguity) QualifiedName? QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     (rule start) 'ClassDescription' '{' (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     (rule start) 'ClassDescription' '{' (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     (rule start) 'ClassDescription' '{' (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     (rule start) 'ClassDescription' '{' (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     (rule start) 'ClassDescription' '{' (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? '}' (rule start)
	 *     description=EString (ambiguity) 'hasConcreteProperty' hasConcreteProperty=Boolean
	 *     description=EString (ambiguity) QualifiedName? 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     description=EString (ambiguity) QualifiedName? QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     description=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     description=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     description=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     description=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     description=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     filestogenerate=EString (ambiguity) 'hasConcreteProperty' hasConcreteProperty=Boolean
	 *     filestogenerate=EString (ambiguity) QualifiedName? 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     filestogenerate=EString (ambiguity) QualifiedName? QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     filestogenerate=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     filestogenerate=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     filestogenerate=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     filestogenerate=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     filestogenerate=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     language=Language (ambiguity) 'hasConcreteProperty' hasConcreteProperty=Boolean
	 *     language=Language (ambiguity) QualifiedName? 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     language=Language (ambiguity) QualifiedName? QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     language=Language (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     language=Language (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     language=Language (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     language=Language (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     language=Language (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     license=EString (ambiguity) 'hasConcreteProperty' hasConcreteProperty=Boolean
	 *     license=EString (ambiguity) QualifiedName? 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     license=EString (ambiguity) QualifiedName? QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     license=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     license=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     license=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     license=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     license=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     sourcePath=EString (ambiguity) 'hasConcreteProperty' hasConcreteProperty=Boolean
	 *     sourcePath=EString (ambiguity) QualifiedName? 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     sourcePath=EString (ambiguity) QualifiedName? QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     sourcePath=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     sourcePath=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     sourcePath=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     sourcePath=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     sourcePath=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 *     title=EString (ambiguity) 'hasConcreteProperty' hasConcreteProperty=Boolean
	 *     title=EString (ambiguity) QualifiedName? 'hasAbstractCommand' hasAbstractCommand=Boolean
	 *     title=EString (ambiguity) QualifiedName? QualifiedName? 'hasAbstractAttribute' hasAbstractAttribute=Boolean
	 *     title=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? 'descriptionHtmlExists' descriptionHtmlExists=Boolean
	 *     title=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'comments' comments=Comments
	 *     title=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'identification' identification=ClassIdentification
	 *     title=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? 'inheritances' '{' inheritances+=Inheritance
	 *     title=EString (ambiguity) QualifiedName? QualifiedName? QualifiedName? QualifiedName? '}' (rule end)
	 */
	protected void emit_ClassDescription_QualifiedNameParserRuleCall_9_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     QualifiedName?
	 *
	 * This ambiguous syntax occurs at:
	 *     description=EString (ambiguity) 'argin' argin=Argument
	 *     description=EString (ambiguity) 'argout' argout=Argument
	 *     description=EString (ambiguity) 'excludedStates' '{' excludedStates+=EString
	 *     description=EString (ambiguity) 'isDynamic' isDynamic=EString
	 *     description=EString (ambiguity) 'polledPeriod' polledPeriod=EString
	 *     description=EString (ambiguity) 'status' status=InheritanceStatus
	 *     description=EString (ambiguity) '}' (rule end)
	 *     execMethod=EString (ambiguity) 'argin' argin=Argument
	 *     execMethod=EString (ambiguity) 'argout' argout=Argument
	 *     execMethod=EString (ambiguity) 'excludedStates' '{' excludedStates+=EString
	 *     execMethod=EString (ambiguity) 'isDynamic' isDynamic=EString
	 *     execMethod=EString (ambiguity) 'polledPeriod' polledPeriod=EString
	 *     execMethod=EString (ambiguity) 'status' status=InheritanceStatus
	 *     execMethod=EString (ambiguity) '}' (rule end)
	 *     name=EString '{' (ambiguity) 'argin' argin=Argument
	 *     name=EString '{' (ambiguity) 'argout' argout=Argument
	 *     name=EString '{' (ambiguity) 'excludedStates' '{' excludedStates+=EString
	 *     name=EString '{' (ambiguity) 'isDynamic' isDynamic=EString
	 *     name=EString '{' (ambiguity) 'polledPeriod' polledPeriod=EString
	 *     name=EString '{' (ambiguity) 'status' status=InheritanceStatus
	 *     name=EString '{' (ambiguity) '}' (rule end)
	 */
	protected void emit_Command_QualifiedNameParserRuleCall_6_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     QualifiedName?
	 *
	 * This ambiguous syntax occurs at:
	 *     description=EString (ambiguity) 'readExcludedStates' '{' readExcludedStates+=EString
	 *     description=EString (ambiguity) 'writeExcludedStates' '{' writeExcludedStates+=EString
	 *     description=EString (ambiguity) '}' (rule end)
	 *     label=EString (ambiguity) 'readExcludedStates' '{' readExcludedStates+=EString
	 *     label=EString (ambiguity) 'writeExcludedStates' '{' writeExcludedStates+=EString
	 *     label=EString (ambiguity) '}' (rule end)
	 *     name=EString '{' (ambiguity) 'readExcludedStates' '{' readExcludedStates+=EString
	 *     name=EString '{' (ambiguity) 'writeExcludedStates' '{' writeExcludedStates+=EString
	 *     name=EString '{' (ambiguity) '}' (rule end)
	 *     rwType=EString (ambiguity) 'readExcludedStates' '{' readExcludedStates+=EString
	 *     rwType=EString (ambiguity) 'writeExcludedStates' '{' writeExcludedStates+=EString
	 *     rwType=EString (ambiguity) '}' (rule end)
	 */
	protected void emit_Pipe_QualifiedNameParserRuleCall_7_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
